#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdarg.h>
#include <sys/time.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

/* If your system doesnt have this, try commenting it out. */
//#include <crypt.h>

/* If there are problems and you want all X2 output to go to x2.debug, define
 * this.  Note that it gets very big, very fast...
 * #define LOGALLDEBUG 
 */

/* This is the CTCP character.  (^A)
 */
#define CTCP		'\001'
#define BOLD            '\002'
#define INVERTED        '\026'
#define CLEARALL        '\017'
 
/*
 * Please do not remove the name 'X2' and the version from this reply. If you 
 * make modifications please use the format: 5.1+<yournet>.<yourversion>
 * Or, use one of the replies provided.  Obviously theres no way for me
 * to enforce this, but I have put many hundreds of hours into this program
 * and I'd like to be able to tell whos using it and what version it is based
 * on.
 * [alternate replies]
 * #define VERSION         "X2 v5.1 - Channel and Oper services"
 * #define VERSION         "<YourNet> Channel services powered by Rubin's X2 version 5.1"
 */
#define VERSION	        "X2 v5.1 - AfterNET Channel Services"

/* This is used to refer to your network in various places. It should be one word, eg "AfterNET" */
#define NETWORK         "Loxxin"
#define HELPURL         "http://x2.afternet.org"

#define OPERHELPFILE	"HELP/operhelp.txt"
#define USERHELPFILE	"HELP/userhelp.txt"
#define MESSAGEFILENAME "x2.news"		/* this isnt working yet.. */
#define GATEFILENAME    "wingate.log"           /* detected wingates written to disk */
#define ProcFilePath	"x2.pid"
#define AccountingLog   "accounting.log"	/* Every command is logged */
#define ExpiredChanLog	"expired.log"		/* Log for expired Channels */
#define DefaultConfigFile "x2.conf"
#define log

/* Some URL to give insecure wingate folks...  Undernet's URL works...  Hehehe. */
#define GATEURL "http://help.undernet.org/proxyscan.htm"

/* Uncomment the following for debugging.
*/   
   #define debugon

/* Older afternet ircu had a mode (+g) added that made
 * IRC Ops able to override X2 security (God mode)
 * Current afternet ircu (runs universal ircu) uses
 * +h for this (we call it helper).
 * If your ircu does not support this, be sure to #undef
 * AFTERNET below and choose an unused mode for this:
 */
#define OVERRIDEMODE "h"

/* If your ircd does not have an override mode for use with X2
 * please undefine this so you can /msg X2 GOD on/off
 */
#define AFTERNET

/* If you dont want the word warez in channel names, define this.
 * TODO : This is a hack, and would do better in a config file. Do it!
 */
#define NOWAREZCHANS

/* `pinging' instructs X2 to ping the server to see if it has a dead
 * connection--this is a GOOD idea... */
#define pinging

/* dont touch this one.. there were bugs in the topic code but they all work fine now */
/* Don't modify this one :: There were bugs in the topic code, but they
 * all work fine now. */
#define TOPICENABLED

#define CHANFILENAME    "chan.dat"
#define ROUTFILENAME    "ROUTES/routing.dat"
#define GLINEFILENAME   "gline.dat"
#define SUPERGLINEFILENAME "supergline.dat"

/* These are for the Wingate check. */
#define MAXGATESOCKS 20
#define GATECHECKTIMEOUT 60
#define GATECHECKSENDTIMEOUT 30
#define SOCKSPORT 1080
#define WAIT_TO_CONNECT 0
#define WAIT_TO_SEND  1
#define WAIT_TO_READ  2
#define WAIT_TOO_MANY 3


#define FLOODINTERVAL   6
#define PINGTIMEOUT     60
#define PINGFREQ        60
#define STRTOLSIZE      6
#define STRTOLBASE      36

#define LOCALIP 16777343  /* 0x0100007F (hex) */

/* Maximum number of severe errors before X2 shuts down. */
#define MAXDBGSEVERE   5

/* The SEGSIZE options set up how big the array thats used for super fast
 * lookups of data are. They should be prime numbers and at least twice as 
 * big as the maximum number of items that will be in the array.
 * These values work well for AfterNet, which runs just under 800 channels
 * and 900 users at peak time.  The bot will notify you via wallops if
 * these need to be increased.  Small values only hurt performance, every-
 * thing will remain functional. */
#define CHANSEGSIZE     3001
#define USERSEGSIZE     3001
#define SERVERSEGSIZE   61
#define ROUTSEGSIZE     SERVERSEGSIZE
#define NETSEGSIZE      41
#define NETLINKSEGSIZE  21
#define OPERSEGSIZE     401
#define SERVNAMESEGSIZE 21
#define NETCHANMAXSIZE  21
#define MAXNUMNICKNUM   65
#define MAXLOGINLEN     10

/* This is the max # of lines of accounting.log
 * that will be read while trying to display
 * the last n lines of a spesific channels info.
 * the bigger it is, the more cpu can be wasted
 * by a chan owner.
 */
#define MAXLOGSEARCHLENGTH 10000

/* These are for userlist entries. */
#define MAXHANDLELEN    20
#define MAXMASKLEN      100

#define MAXCHANLISTLEN  500

#define MAXBANLEN       150
/* Make sure this is (+1?) larger than your networks nick length.
 * The default is 9.  AfterNET runs 30. */
#define MAXNICKLEN	31
#define MAXCIDLEN       10      /* TS4 Connection ID (no idea whats reasonable). */
#define NUMNICKLEN      4       /* 1 char (server number) + 2 char (user number) + '\0' */
#define PASSWORDLEN     10      /* Some bugs with long passwords have  been reported.
                                 * This should solve it. */
#define MAXPASS         200	/* No longer used for ban reason.  Shrinking... */
#define GENPASSLEN      6       /* Passwords of this length are auto-generated by X2. */
#define MAXINFOLEN      160     /* Info Lines */
#define MAXNUMOFARGS	80
#define MAXLEN		540	/* Use all over the place, set it pretty large. */
#define MAXCHANLEN	256	/* This must be >= what ircd uses. */
#define MAXSERVERLEN    500     /* Must be the longest length a server name will have. */
#define MAXCHANKEY      56

#define MAXCONFSTRBUFF  256
/* Bringing LINEBUFFSIZE up from 128 to 512 to solve possible.
 * topic overflow problems.
 * #define LINEBUFFSIZE    512 */
#define LINEBUFFSIZE    2048  /* Must be enough to hold topic
                               * and description, etc. */
/* TOPIC LENGTH NOT TO EXCEDE LINEBUFFSIZE!!! */
#define MAXTOPICLEN	160
#define MAXEMAILLEN     200
#define MAXURLLEN       160
#define MAXDESCLEN      500
#define INBUFFSIZE      1024
#define MAXLINES        (INBUFFSIZE/10)
#define LINETRUNKSIZE   200
#define MAXRECVLEN      2000
#define MAXLINELEN      300

/* Channels unvisited by (co)owner will be automatically 
 * removed when they reach this many days old.
 */
#define CHANEXPIREDAYS  30

/* This time stamp is used as the date registered channels were created in X2.
 *  It should be older then the oldest channel on the network, or X2 wont get
 *  ops.  All channels registered on the net will have this timestamp displayed.
 */
#define BURSTCHANNELDATE 691085573   /* Mon Nov 25 08:12:53 1991 */

/* These are the constants that determine how often a user can use
 * X2's invite.
 */
#define MAXINVITE       120
#define DELTAINVITE     40

/* These are for channel mode parsing */
#define NOMODES         0
#define CMODEe          512
#define CMODER          256
#define CMODEn          128
#define CMODEt          64
#define CMODEs          32
#define CMODEp          16
#define CMODEi          8
#define CMODEl          4
#define CMODEk          2
#define CMODEm          1

/* These are for User mode parsing.. */
#define UMODEaway       2048
#define UMODEgod        1024
#define UMODER          512
#define UMODEr          256
#define UMODEx          128
#define UMODEs          64
#define UMODEk          32
#define UMODEo          16
#define UMODEd          8
#define UMODEw          4
#define UMODEi          2
#define UMODEg          1

/* User levels:  */
/* TODO : I'd like to get in the habit of using these instead of ever
 * hard coding a number into the source.  If anyone wants to
 * go though and replace all the hard coded places, that would be cool.
 */
#define OW 300  /* Owner */
#define CO 290  /* Co Owner */
#define MA 200  /* Manager */
#define OP 100  /* Op */
#define PE 10   /* Peon */


/* In parse.c, the command parameter from the server is converted
 * to an int.  These have been pre-calculated to match...  Thus,
 * switch() can be used on strings (:
 * I realize how annoying this is to add onto, but it's not hard
 * to write a quick C function to make new ones.
 * -
 * Update: These aren't even used anymore, I dont think.
 *   -Rubin
 */
#define NICK		1096868l
#define SERVER		1717867971l
#define MODE		1058018l
#define JOIN		918239l
#define PART		1180361
#define KICK		956900l
#define SQUIT		48281861l
#define PRIVMS	        1557884836l
#define QUIT		1252613l
#define KILL            957225l

/* These are numerics, I think.   *
 * Not sure, where they are used. */
#define INVITEONLY	473
#define BANNED		474
#define JOINED		353

/* These are the various debug levels. */
#define DBGNOTICE   10
#define DBGINFO     20
#define DBGWARNING  30
#define DBGERROR    40
#define DBGSEVERE   50

#define SEPERATORS  ".,;\n "
#define null(type) (type) 0L
#ifndef NULL
#define NULL(type) (type)0
#endif
#ifndef TRUE
#define TRUE     1
#define FALSE    0
#endif

#define Reg1 register

typedef enum
{
  false, true
}
boolean;

typedef struct NetMessageStruct
{
  time_t Timestamp;
}
NetMessageType;

/* This is going away, soon. replaced with the NEW system. */
#if 0
typedef struct OperStruct
{
  char *Address;
  char Pass[MAXPASS];
  char Handle[20];
  char Info[200];
  int AutoOp;
  int PwdReq;
  time_t LastSeen;
  int inchan;
  struct OperStruct *Next;
}
*OperListType;
#endif

#if 0
typedef struct OperSegStruct
{
  OperListType Table[OPERSEGSIZE];
  struct OperSegStruct *Next;
}
*OperSegment;
#endif

/* This is the smallest unit of the userlist. Each person
 * has large number of these, for each ISP etc. */
typedef struct MaskStruct
{
  char *Mask;
  struct MaskStruct *Next;
}
*MaskListType;

/* This is an account for a user in a channel.
 * It has some settings, password, infoline, 
 * and a list of hosts.
 */
typedef struct HandleStruct
{
   char *Handle;                /* This account name */
   char Level;                  /* W/C/M/O/P/L etc */
   char *Pass;                  /* Password.. */
   char *Info;                  /* Info line */
   int AutoOp;                  /* Auto Op toggle */
   time_t LastSeen;             /* last seem timestamp */
   int InChan;                  /* Are they in chan now? */
   struct AuthUserStruct *AuthUsers;   /* A list of users who are logged in as this handle */
   struct MaskStruct *Masks;     /* list of masks */
   struct HandleStruct *Next;
}
*HandleListType;

typedef struct LamerStruct
{
   char* Mask;  /* *!*@* of the ban */
   char* Reason; /* Why were they banned */
   time_t Time;  /* Time they were banned */
   time_t LastSeen; /* Last time a match was seen */
   struct LamerStruct *Next;
} *LamerListType;

typedef struct AuthUserStruct
{
  struct UserStruct *uptr;     /* The user who'se logged in as the handle */
  struct AuthUserStruct *Next;
} *AuthUserListType;

typedef struct AuthHandleStruct
{
  struct ChanStruct *cptr;  /* The channel the user is logged in as */
  struct HandleStruct *hptr;   /* The handle in that channel */
  struct AuthHandleStruct *Next;
} *AuthHandleListType;

typedef struct BanStruct
{
  char banstring[MAXBANLEN];	/* banned nick!user@host */
  time_t time;
  struct BanStruct *Next;	/* Next ban */
} 
*BanListType;

typedef struct GlineStruct
{
  char address[MAXLEN];		/* User@Host */
  char reason[MAXLEN];		/* <Nick> ... */
  time_t time;
  struct GlineStruct *Next;
}
GlineListType;

typedef struct StatsStruct
{
  unsigned long int day[30];  /* count for each of the last 30 days */
  unsigned long int hour[24]; /* count for each of the last 24 hours */
} StatsType;

typedef struct ServerStatsStruct
{
   struct StatsStruct PingOuts;  /* Number of pingouts over various ammns of time */
   struct StatsStruct WriteErrors; /* Number of write errors over various ammounts of time. */
} ServerStatsType;

typedef struct RouteListStruct
{
  char* server;  /* Name of the server */
  int port;      /* Connection port */
  int karma;     /* server connection reliablity */
  char* uplink;  /* Server its linked to (toward us) */
  char* secondaryuplink; /* Another server it could link to (not yet implimented) */
  int outsideness;       /* 0 means 'leaf' 1 second layer, etc etc etc */
  struct RouteListStruct *next; /* Next in the list */
}
 *RouteListType;

typedef struct RouteStruct
{
  int count;            /* how many servers we have */
  int maxdepth;         /* biggest outsideness value */
  int centered;         /* Set to TRUE when ChangeRouteUplinks is run */
  struct RouteListStruct *servers;
} *RouteType;

extern RouteType Route;  /* Main routing table */

/* This defines which element of the set array is which setting.
 * It doesn't matter as long as they're all different.  Could have 
 * used enum here, I know.
 * Be sure to modify NUMOFCHANSETTINGS below */
#define TOPICFREQ   0
#define STRICTOP    1
#define AUTOOP      2
#define PROTECT     3
#define ENFMODES    4
/*#define PASSMODE    5 unused option have name "" */
#define BANTIMEOUT  6
#define VOICE       7
#define USERINFO    8
#define INCHAN      9
/*#define SUSPENDED   10 */
#define NODELETE    11

/* This MUST be right or a crash or file corruption may result!
 * this INCLUDES the 0th setting. (0-11 would be 12) */
#define NUMOFCHANSETTINGS 12

typedef struct set_listType
{
  char *name;
  int index;
  int level;
  int user;   /* Is it a user modifyable thing? */
  int num;
  int def;
  char *description;
  char *pre;
  char settings[6][45];
} set_list;
extern set_list set_commands[NUMOFCHANSETTINGS+1];

/* This is all we know about a NICK on IRC */
typedef struct UserStruct
{
  char Nick[MAXNICKLEN];
  char Numnick[NUMNICKLEN];
  char UserID[12];
  char *Address;
  unsigned int IP;
  struct AuthHandleStruct *AuthHandles;  /* A list of channel and handles were logged in as */
  char *RealName;
  char *Serv;
  struct JoinedChansStruct *Chans;
  int Clones;
  unsigned int Modes;        /* 0  0 0 0 0 0 0 0 0 0 0 = bits */
  time_t LastInvite;
  struct UserStruct *NextA;
  struct UserStruct *NextN;
  struct UserStruct *NextU;
}
*UserListType;

typedef struct JoinedChansStruct
{
  struct ChanStruct *cptr;
  struct JoinedChansStruct *Next;
} *JoinedChansListType;

/* This is a list of who's in the channel */
typedef struct ChanUserStruct
{
	UserListType User;
	struct ChanUserStruct *Next;
}*ChannelUsersListType;

/* All we know about every existing channel on irc, reg'd or not.
 * for unregistered channels, some values are NULL.
 */
typedef struct ChanStruct
{
  char *Name;			/* n t s p i l k m = modes */
  unsigned int Modes;	        /* 0 0 0 0 0 0 0 0 0 = bits */
  char *Topic;			/* 9 8 7 6 5 4 3 2 1 = bit position */
  char *Email;
  char *Description;
  char *URL;
  char *Reggedby;
  int Regged;
  int NumOfOps;
  int OwnersOnline;
  HandleListType Handles;      /* The userlist */
  LamerListType Lamers;        /* The lamers list (auto-kb)*/
  int settings[NUMOFCHANSETTINGS];
  int PlusModes;
  int MinModes;
  char *Key;
  char *Limit;
  char CurrentKey[MAXCHANKEY];
  time_t LastAccess;
  time_t CreationDate;
  BanListType banned;
  int NumOfNicks;               /* # of people in channel */
  ChannelUsersListType Joined;  /* Ptr (or NULL) to linked list */
                                /* of people in channel.  */
  char *Suspended;				/* NULL if not suspended, reason otherwise */
  time_t SuspendedTime;
  struct ChanStruct *Next;
}
*ChannelListType;

typedef struct ChanSegStruct
{
  ChannelListType Table[CHANSEGSIZE];
/*  struct ChanSegStruct *Next;*/
}
*ChanSegment;

typedef struct ServStruct
{
  char *Name;
  char *LinkName;
  char *Description;
  char numnick;
  int NumOfUsers;
  int Deleted;
  struct ServStruct *NextA; /* jump by nAme */
  struct ServStruct *NextU; /* jump by nUmber */
}
*ServerListType;

typedef struct ServSegStruct
{
  ServerListType Table[SERVERSEGSIZE];
  ServerListType TableU[MAXNUMNICKNUM];
/*  struct ServStruct *Next;*/
}
*ServSegment;

typedef struct UserSegStruct
{
  UserListType Table[USERSEGSIZE];
/*  struct UserSegStruct *Next;*/
}
*UserSegment;

typedef struct ServNameStruct
{
  char *ServName;
  struct ServNameStruct *Next;
}
*ServNameListType;

typedef struct ServNameSegStruct
{
  ServNameListType Table[SERVNAMESEGSIZE];
/*  struct ServNameSegStruct *Next;*/
}
*ServNameSegment;

typedef struct UpLinkSegStruct
{
   char ServName[MAXLEN];
   char ServIp[MAXLEN];
   char ServPass[20];
   int  Port;
   struct UpLinkSegStruct *Next;
}
UpLinkList;

/* This is who we are currently scanning for wingates. */
typedef struct GateListStruct 
{
        char nick[MAXLEN];           /* nick of the user */
        char iphost[MAXLEN];         /* userip reply ip address */
        int sock;                    /* our socket connection */
        time_t timestamp;            /* The timestamp */
        int delete;                  /* is this entry deleted? */
        int state;                   /* stage of connection (Wait to send/read) */
        struct GateListStruct *next; /* The next one...*/
} GateListType;


typedef struct AdminPortListStruct
{
    int sock;    /* the socket connection */
    int auth;    /* 1 if login ok. 2 if not */
    char *login; /* login name */

    struct AdminPortListStruct *Next;
} *AdminPortListType;

typedef struct AdminLoginListStruct
{
    char login[MAXLOGINLEN]; /* login name */
    char pwd[MAXLOGINLEN];   /* login password */

    struct AdminLoginListStruct *Next;
} *AdminLoginListType;


extern UpLinkList *UpLinks;
extern boolean AUTOROUTING, AUTOCONNECT, ENFORCEOPS, PINGOUTCONNECT, GATECHECK,
               FLOODCONTROL, NETLINK, NETTALK, PUBLIC, NETBURSTING;
extern unsigned char CLONERES, MAXCLONES, MAXCHAN, DEBUG, SUB7SCAN;

extern char DBTARGET[MAXLEN];

extern char DefServHost[MAXLEN], ServiceName[MAXLEN],
            Uplink[MAXLEN], ServAddress[16], Password[20], 
            IrcNick[MAXNICKLEN], 
            CommandMark, HomeDir[2048];

extern int ServiceNumeric;
extern char NumNick[NUMNICKLEN];

extern u_short Port, SERVERPORT;
extern int Sock, NewSock;
extern struct sockaddr_in ServAddr, CliAddr;
extern fd_set fdvar, wfdvar;
extern int MaxSock;

extern boolean SockConnected;
extern boolean ServerConnected;
extern boolean SentBurst, Authenticated;
extern boolean RoutsOk;
extern int GotPong;

extern time_t LinkTimeStamp, ServerTimeStamp, ConnectTime, StartTime, DiscTime,
              PingStamp, PongStamp, FloodStamp;
extern long int NetOffset;
extern time_t bantimer;

extern char LastNickAdded[MAXNICKLEN];
extern char LastRequestNick[MAXNICKLEN];

extern ChanSegment Channels;
extern GlineListType *Glines;
extern GlineListType *SuperGlines;
extern ServSegment Servers, Routs;
extern UserSegment UsersN, UsersA;

extern UserSegment UsersU;

extern NetMessageType NetMessage;
extern UpLinkList *CurUpLink;
extern GateListType *GatePtrs;

extern int ChannelCount, ServerCount, RoutCount, UserCount, OperCount,
           PeonCount, OpCount, ManagerCount, CoOwnerCount, OwnerCount, LamerCount;

/* This converts base10 server numeric into a charactor for
 *  * P10  Juse like: convert2y[n] where n is the numeric.
 *   */
extern const char convert2y[];
extern const unsigned int convert2n[];
